# Bouchons

Here lies the custom "bouchons" that we had to do.

To build the docker image of a bouchon:

```
./docker_build.sh <bouchon name> [<version>]
```

## MDT

Bouchon for the "mandataire".

Curently this MDT :
- replies `503 Service Unavailable` when you try to call number `27710997` (specific number) : this is to simulate preemption by the MDT
- replies `606 Not Acceptable` when you try to call number `27710998` (specific number) : this is to simulate preemption by the MDT
- routes all other incoming traffic
  - either to the PEER_MDT (i.e. the MDT of the other station)
  - or to the LOCAL_XIVO (i.e. the asterisk of the same station)

The switch is done on the header Route which is added on the XiVO when calling its local MDT and which contains the IP of the peer MDT. 


To run it, launch the following docker command:

Usage on SMM1:
```bash
LOCAL_XIVO_IP=10.181.7.20
LOCAL_MDT_PORT=45060
PEER_MDT_IP=10.181.7.21
PEER_MDT_PORT=45060

docker run \
    -p ${LOCAL_MDT_PORT}:${LOCAL_MDT_PORT}/udp \
    -e PEER_MDT_IP=${PEER_MDT_IP} \
    -e PEER_MDT_PORT=${PEER_MDT_PORT} \
    -e LOCAL_XIVO_IP=${LOCAL_XIVO_IP} \
    --name=local_mdt \
    mdt:latest --alias=${LOCAL_XIVO_IP}:${LOCAL_MDT_PORT} -l udp:0.0.0.0:${LOCAL_MDT_PORT}/${LOCAL_XIVO_IP}:${LOCAL_MDT_PORT}
```

Usage on SMM2:
```bash
LOCAL_XIVO_IP=10.181.7.21
LOCAL_MDT_PORT=45060
PEER_MDT_IP=10.181.7.20
PEER_MDT_PORT=45060

docker run \
    -p ${LOCAL_MDT_PORT}:${LOCAL_MDT_PORT}/udp \
    -e PEER_MDT_IP=${PEER_MDT_IP} \
    -e PEER_MDT_PORT=${PEER_MDT_PORT} \
    -e LOCAL_XIVO_IP=${LOCAL_XIVO_IP} \
    --name=local_mdt \
    mdt:latest --alias=${LOCAL_XIVO_IP}:${LOCAL_MDT_PORT} -l udp:0.0.0.0:${LOCAL_MDT_PORT}/${LOCAL_XIVO_IP}:${LOCAL_MDT_PORT}
```

You also need to add in your local DNS an entry saying a user is on station 2.
For example:
- if you affiliate 27710001 on SMM2.
- then you need to manually add an entry in the DNS of SMM1

Notice in the following example the `10.181.7.21` (SMM2 IP) in the domaion part of the URI:
```bash
nsupdate -k /var/local/thales/dns/keys.conf
> server 172.20.0.2 53
> update add 1.0.0.0.1.7.7.2.dynamique.local. 60 IN  NAPTR 100 10 "u" "E2U+sip" "!^.*$!sip:27710001@10.181.7.21!" .
> show
> send
```

- to revoke the "fake" affiliation:
```bash
nsupdate -k /var/local/thales/dns/keys.conf
> server 172.20.0.2 53
> update delete 1.0.0.0.1.7.7.2.dynamique.local.
> show
> send
```