# -*- coding: utf-8 -*-

# Copyright (C) 2010-2014 Avencall
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>

from xivo_agid import agid

import logging

logger = logging.getLogger(__name__)

def _translate(cursor, number):
    sql = "SELECT lf.provisioningid " \
             "FROM linefeatures lf " \
             "JOIN user_line ul ON lf.id = ul.line_id " \
             "JOIN userfeatures uf ON uf.id = ul.user_id " \
             "WHERE uf.description = '%s'" % number
    cursor.query(sql)
    res = cursor.fetchall()
    return res[0][0] if len(res) == 1 else number


def provisioning_translate(agi, cursor, args):
    try:
        number = agi.get_variable('SUBSCRIBER_NUMBER')
        provisioning = _translate(cursor, number)
        agi.set_variable('TRANSLATED_EXTEN', provisioning)
    except Exception as e:
        logger.error('Error during translating provisioning number: %s', e)
        agi.dp_break(e)

agid.register(provisioning_translate)
