#!/usr/bin/python3
# -*- coding: UTF-8 -*-
# Copyright (C) 2021  Thales
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,

from builtins import object
from xivo.agi import AGI

import logging
import sys
import traceback
import subprocess
import os
import re

DEBUG_MODE = True
LOGFILE = '/var/log/xivo-user-subscription.log'

DNS_HOST = 'ns1.telecom.thales.local'
DNS_PORT = '53'
DNS_ZONE = 'telecom.thales.local'
DNS_TTL  = 60

KEYFILE_PATH = '/usr/src/DNSKeys/Ktelecom.thales.local.+165+58574.key'
ASTERISK_HOST = '10.20.21.11'

agi = AGI()
logger = logging.getLogger()

class Syslogger(object):

    def write(self, data):
        global logger
        logger.error(data)

def init_logging(debug_mode):
    if debug_mode:
        logger.setLevel(logging.DEBUG)
    else:
        logger.setlevel(logging.INFO)

    logfilehandler = logging.FileHandler(LOGFILE)

    formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
    logfilehandler.setFormatter(formatter)
    logger.addHandler(logfilehandler)

    syslogger= Syslogger()
    sys.stderr = syslogger

def report_error(cause):
    agi.verbose("Error: %s", cause)
    logger.error(cause)
    agi.set_variable('user-suscribe-result', '-1')
    agi.set_variable('error-cause', cause)
    sys.exit(1)

def format_subscriber_for_enum(number):
    full_number = '2' + number
    return '.'.join(full_number[::-1])


def checkJunction(subscriberNumber):

    calledNumber = sys.argv[1].strip()
    subscriberNumber = calledNumber[3:10]
    subscriber_enum_formatted = format_subscriber_for_enum(subscriberNumber)
	
    command = "dig @{0} -p {1} -t naptr {2}.{3}".format(DNS_HOST, DNS_PORT, subscriber_enum_formatted, DNS_ZONE)
    process = subprocess.Popen(command.split(), stdout=subprocess.PIPE)
    output, error = process.communicate()

    logger.debug('ENUM lookup : %s', command)
    if error != None:
        report_error(error)
        is_existing = False
        if (";; ANSWER SECTION:" in output):
            logger.debug('Found a result : %s', output)
            if not checkjunction(subscriber_enum_formatted):
                report_error("There is no subscriber within the DNS")
            is_existing = True
        else:
            logger.debug("No result found : %s", output)

    else:
            report_error('Undefined request')
            sys.exit(1)   

	
if __name__ == '__main__':
    main()
